/*
*	New C++ File starts here.
*	This file should be named rlsn.cpp
*/

// Include all NML, CMS, and RCS classes and functions
#include "rcs.hh"

// Include command and status message definitions
#include "rlsn.hh"

// Forward Function Prototypes

/*
*	NML/CMS Format function : rlsFormat
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
int rlsFormat(NMLTYPE type, void *buffer, CMS *cms)
{
	switch(type)
	{
	case RLS_ESTIMATE_TYPE:
		((RLS_ESTIMATE *) buffer)->update(cms);
		break;
	case RLS_HALT_TYPE:
		((RLS_HALT *) buffer)->update(cms);
		break;
	case RLS_INIT_TYPE:
		((RLS_INIT *) buffer)->update(cms);
		break;
	case RLS_SET_COVARIANCE_TYPE:
		((RLS_SET_COVARIANCE *) buffer)->update(cms);
		break;
	case RLS_SET_LAMBDA_TYPE:
		((RLS_SET_LAMBDA *) buffer)->update(cms);
		break;
	case RLS_SET_PARAM_TYPE:
		((RLS_SET_PARAM *) buffer)->update(cms);
		break;
	case RLS_STATUS_TYPE:
		((RLS_STATUS *) buffer)->update(cms);
		break;

	default:
		return(0);
	}
	return 1;
}


// NML Symbol Lookup Function
const char *rls_symbol_lookup(int type)
{
	switch(type)
	{
	case RLS_ESTIMATE_TYPE:
		return "RLS_ESTIMATE";
	case RLS_HALT_TYPE:
		return "RLS_HALT";
	case RLS_INIT_TYPE:
		return "RLS_INIT";
	case RLS_SET_COVARIANCE_TYPE:
		return "RLS_SET_COVARIANCE";
	case RLS_SET_LAMBDA_TYPE:
		return "RLS_SET_LAMBDA";
	case RLS_SET_PARAM_TYPE:
		return "RLS_SET_PARAM";
	case RLS_STATUS_TYPE:
		return "RLS_STATUS";
	default:
		return"UNKNOWN";
		break;
	}
	return(NULL);
}

/*
*	NML/CMS Update function for RLS_ESTIMATE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_ESTIMATE::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for RLS_SET_COVARIANCE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_SET_COVARIANCE::update(CMS *cms)
{
	cms->update(diag_value);

}


/*
*	NML/CMS Update function for RLS_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_STATUS::update(CMS *cms)
{
	cms->update(param_estimates,5);
	cms->update(output_error);

}


/*
*	NML/CMS Update function for RLS_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_HALT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for RLS_SET_PARAM
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_SET_PARAM::update(CMS *cms)
{
	cms->update(params_to_set,5);

}


/*
*	NML/CMS Update function for RLS_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_INIT::update(CMS *cms)
{

}


/*
*	NML/CMS Update function for RLS_SET_LAMBDA
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
void RLS_SET_LAMBDA::update(CMS *cms)
{
	cms->update(lambda);

}

/*
*	Constructor for RLS_ESTIMATE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_ESTIMATE::RLS_ESTIMATE()
	: RCS_CMD_MSG(RLS_ESTIMATE_TYPE,sizeof(RLS_ESTIMATE))
{

}

/*
*	Constructor for RLS_SET_COVARIANCE
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_SET_COVARIANCE::RLS_SET_COVARIANCE()
	: RCS_CMD_MSG(RLS_SET_COVARIANCE_TYPE,sizeof(RLS_SET_COVARIANCE))
{
	diag_value = (double) 0;

}

/*
*	Constructor for RLS_STATUS
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_STATUS::RLS_STATUS()
	: RCS_STAT_MSG(RLS_STATUS_TYPE,sizeof(RLS_STATUS))
{
	/*
	* The array param_estimates should be initialized here.
	*/

	output_error = (double) 0;

}

/*
*	Constructor for RLS_HALT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_HALT::RLS_HALT()
	: RCS_CMD_MSG(RLS_HALT_TYPE,sizeof(RLS_HALT))
{

}

/*
*	Constructor for RLS_SET_PARAM
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_SET_PARAM::RLS_SET_PARAM()
	: RCS_CMD_MSG(RLS_SET_PARAM_TYPE,sizeof(RLS_SET_PARAM))
{
	/*
	* The array params_to_set should be initialized here.
	*/


}

/*
*	Constructor for RLS_INIT
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_INIT::RLS_INIT()
	: RCS_CMD_MSG(RLS_INIT_TYPE,sizeof(RLS_INIT))
{

}

/*
*	Constructor for RLS_SET_LAMBDA
*	Automatically generated by RCS Java Diagnostics Tool.
*	on Mon Dec 18 13:20:58 EST 2000
*/
RLS_SET_LAMBDA::RLS_SET_LAMBDA()
	: RCS_CMD_MSG(RLS_SET_LAMBDA_TYPE,sizeof(RLS_SET_LAMBDA))
{
	lambda = (double) 0;

}

