/*
rlsn.hh

This C++ header file defines the NML Messages used for command and status by RLS_MODULE
Template Version 1.1

MODIFICATIONS:
Sun Dec 17 20:48:04 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef RLSN_HH
#define RLSN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.

#define NUM_OF_PARAMS 5

// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define RLS_STATUS_TYPE 1000
#define RLS_ESTIMATE_TYPE 1001
#define RLS_HALT_TYPE 1002
#define RLS_INIT_TYPE 1003
#define RLS_SET_COVARIANCE_TYPE 1004
#define RLS_SET_LAMBDA_TYPE 1005
#define RLS_SET_PARAM_TYPE 1006
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class RLS_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	RLS_STATUS();

	// Constructor used by derived classes
	RLS_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double param_estimates[NUM_OF_PARAMS];
  double output_error;
  
};

// Command Classes

class RLS_ESTIMATE : public RCS_CMD_MSG
{
public:

	//Constructor
	RLS_ESTIMATE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RLS_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	RLS_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class RLS_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	RLS_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  
};

class RLS_SET_COVARIANCE : public RCS_CMD_MSG
{
public:

	//Constructor
	RLS_SET_COVARIANCE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double diag_value;
};

class RLS_SET_LAMBDA : public RCS_CMD_MSG
{
public:

	//Constructor
	RLS_SET_LAMBDA();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double lambda;
};

class RLS_SET_PARAM : public RCS_CMD_MSG
{
public:

	//Constructor
	RLS_SET_PARAM();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double params_to_set[NUM_OF_PARAMS];
  
};

// Declare NML format function
extern int rlsFormat(NMLTYPE, void *, CMS *);

#endif 	// RLSN_HH
