/*
	rls_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		RLS_MODULE

	MODIFICATIONS:
	Sun Dec 17 20:48:06 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "rls.hh"	// definition of RLS_MODULE

// flag signifying main loop is to terminate
int rls_module_done = 0;

//signal handler for ^C
extern "C" void rls_module_quit(int sig);
void rls_module_quit(int sig)
{
	rls_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int rls_module_run();

int rls_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	RLS_MODULE *rls = new RLS_MODULE();

	// set the SIGINT handler
	signal(SIGINT, rls_module_quit);

	// enter main loop
	while(!rls_module_done)
	{
		rls->controller();

		timer->wait();
	}

	// Delete Modules
	delete rls;

	// Delete Timer
	delete timer;
}

